VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "mswinsck.ocx"
Begin VB.UserControl BNCS 
   ClientHeight    =   480
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   480
   InvisibleAtRuntime=   -1  'True
   ScaleHeight     =   480
   ScaleWidth      =   480
   Begin MSWinsockLib.Winsock wsMCP 
      Left            =   960
      Top             =   0
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin MSWinsockLib.Winsock wsBNLS 
      Left            =   480
      Top             =   0
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin MSWinsockLib.Winsock wsBNCS 
      Left            =   360
      Top             =   480
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.Image imgIcon 
      Height          =   480
      Left            =   0
      Picture         =   "BNCS.ctx":0000
      Top             =   0
      Width           =   480
   End
End
Attribute VB_Name = "BNCS"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Public events!
Public Event Connecting(strServer As String)
Public Event Connected(strServer As String)
Public Event Disconnected()
'Public Event BNLSConnecting(strServer As String)
'Public Event BNLSConnected(strServer As String)
'Public Event MCPConnecting()
'Public Event MCPConnected()
Public Event LoggedIn(strUsername As String, strProduct As String)
Public Event LoginError(strError As String)
'Public Event ReceivedInvite(strInviter As String)
Public Event ReceivedProfile(strSex As String, strLocation As String, strDescription As String)
Public Event WinsockError(strDescription As String, intNumber As Integer)
'Public Event BNLSWinsockError(strDescription As String, strNumber As String)
Public Event SentChat(strText As String)
Public Event ReceivedChat(strUsername As String, strText As String, lngFlags As Long, lngPing As Long)
Public Event InfoMessage(strMessage As String)
Public Event BnetError(strError As String)
Public Event JoinedChannel(strChannel As String)
Public Event CheckRevisionPassed()
Public Event CheckRevisionFailed(strError As String)
Public Event Emote(strUsername As String, strText As String)
Public Event UserJoined(strUsername As String, lngPing As Long, strProduct As String, lngFlags As Long)
Public Event UserLeave(strUsername As String)
Public Event UserShow(strUsername As String, strProduct As String, lngFlags As Long, lngPing As Long)
Public Event SentWhisper(strMessage As String)
Public Event ReceivedWhisper(strUsername As String, strMessage As String)
Public Event UserFlagUpdate(strUsername As String, strProduct As String, lngPing As Long, lngFlags As Long)
Public Event ReceivedFriends(strFriend As String, bytStatus As Byte, strLocation As String, lngProduct As Long)
Public Event Registered(strEmail As String, strUsername As String)
Public Event CreatedAccount(strUsername As String)
Public Event CreateAccountFailed(strUsername As String, strError As String)
Public Event ServerBroadcast(strMessage As String)
Public Event AccountInformation(strCreated As String, strLastLogin As String, strLastLogoff As String, strTimeLogged As String)
'---------------------------------------------------

'Variables
Public Username As String
Public Password As String
Public Product As String
Public Verbyte As String
Public CDKey As String
Public XPCDKey As String
Public HomeChannel As String
Public BNLSServer As String
Public BNETServer As String
Public CDKeyOwner As String
Public Email As String
Public Register As Boolean
'Public IsOnline As Boolean
'Public UseBNLS As Boolean
Public UsePlug As Boolean
Public UseExpansion As Boolean
Public UniqueUsername As String
Public CurrentChannel As String

'Bnet Variables
Private ValueString As String
Private MPQFilename As String
Private MPQFiletime As String
Private ServerToken As Long
Private ClientToken As Long
Private EXEInfo As String
Private Version As Long
Private CheckSum As Long
Private KeyHash As String * 20
Private KeyHashXP As String * 20
Private ServerKey As String
Private Salt As String

Public HashPath As String
'---------------------------------------------------

'Bot Specific
Public SettingsPath As String
'---------------------------------------------------

'Types
Private Type FILETIME
        dwLowDateTime As Long
        dwHighDateTime As Long
End Type

Private Type SYSTEMTIME
        wYear As Integer
        wMonth As Integer
        wDayOfWeek As Integer
        wDay As Integer
        wHour As Integer
        wMinute As Integer
        wSecond As Integer
        wMilliseconds As Integer
End Type
'---------------------------------------------------

'Declares
Private Debuffer As New clsPacketDebuffer
Private Buffer As New clsPacketBuffer
Private hNLS As Long
Private Declare Function FileTimeToSystemTime Lib "kernel32" ( _
    lpFileTime As FILETIME, _
    lpSystemTime As SYSTEMTIME) As Long
Private Declare Function GetTickCount Lib "kernel32" () As Long

'--------------------
'Code
Private Sub ParseBNCS(data As String)
Dim packetID As Integer

'AddChat 1, &HFFFFC0, Buffer.DebugOutput(data)

packetID = Asc(Mid(data, 2, 1))

Select Case packetID
    Case &H50
        Parse0x50 data
    Case &H51
        Parse0x51 data
    Case &H3A
        Parse0x3A data
    Case &H25
        Parse0x25 data
    Case &HA
        Parse0x0A data
    Case &HF
        Parse0x0F data
    Case &H59
        Parse0x59
    Case &H3D
        Parse0x3D data
    Case &H65
        Parse0x65 data
    Case &H53
        Parse0x53 data
    Case &H54
        parse0x54 data
    Case &H26
        parse0x26 data
End Select

End Sub
Private Sub Send0x50()
With Buffer
    .InsertDWORD 0
    .InsertNonNTString "68XI" & StrReverse(Product)
    .InsertDWORD "&H" & Verbyte
    .InsertDWORD &H0
    .InsertDWORD &H0
    .InsertDWORD &H0
    .InsertDWORD &H0
    .InsertDWORD &H0
    .InsertNTString "USA"
    .InsertNTString "United States"
    .SendPacket &H50, wsBNCS
End With
End Sub
Private Sub Parse0x50(data As String)
Dim LogonType As Long
Dim UDPValue As Long

With Debuffer
    .DebuffPacket data
    .Advance (4)
    LogonType = .DebuffDWORD
    ServerToken = .DebuffDWORD
    UDPValue = .DebuffDWORD
    MPQFiletime = .DebuffFILETIME
    MPQFilename = .DebuffNTString
    ValueString = .DebuffNTString
End With

Send0x51
End Sub
Private Sub Send0x51()
Dim CRResponse As Long
Dim File1 As String
Dim File2 As String
Dim File3 As String
Dim ProdID As Long
Dim Pubvalue As Long
Dim XPPubValue As Long
Dim XPProdID As Long
Dim dcResponse As Long

ClientToken = GetTickCount()
EXEInfo = Space$(256)

Select Case Product
    Case "W2BN"
        CRResponse = checkrevision_ld(HashPath & "\W2BN\Warcraft II BNE.exe", HashPath & "\W2BN\storm.dll", HashPath & "\W2BN\battle.snp", ValueString, Version, CheckSum, EXEInfo, App.Path & "\Lockdown\" & Replace(MPQFilename, ".mpq", ".dll"), HashPath & "\W2BN\w2bn.bin")
    Case "D2DV"
        File1 = HashPath & "\D2DV\Game.exe"
        File2 = HashPath & "\D2DV\bnclient.dll"
        File3 = HashPath & "\D2DV\d2client.dll"
        CRResponse = checkrevision(File1, File2, File3, ValueString, Version, CheckSum, EXEInfo, MPQFilename)
    Case "D2XP"
        File1 = HashPath & "\D2XP\Game.exe"
        File2 = HashPath & "\D2XP\bnclient.dll"
        File3 = HashPath & "\D2XP\d2client.dll"
        CRResponse = checkrevision(File1, File2, File3, ValueString, Version, CheckSum, EXEInfo, MPQFilename)
    Case "WAR3"
        File1 = HashPath & "\WAR3\war3.exe"
        File2 = HashPath & "\WAR3\storm.dll"
        File3 = HashPath & "\WAR3\game.dll"
        CRResponse = checkrevision(File1, File2, File3, ValueString, Version, CheckSum, EXEInfo, MPQFilename)
    Case "W3XP"
        File1 = HashPath & "\WAR3\war3.exe"
        File2 = HashPath & "\WAR3\storm.dll"
        File3 = HashPath & "\WAR3\game.dll"
        CRResponse = checkrevision(File1, File2, File3, ValueString, Version, CheckSum, EXEInfo, MPQFilename)
End Select

If CRResponse = 0 Then
    RaiseEvent CheckRevisionFailed("libbnet.dll failed to properly call checkrevision_ld.  This may be caused if your hashes are not in the hashes folder.")
    Exit Sub
End If
    

dcResponse = decode_hash_cdkey(CDKey, ClientToken, ServerToken, Pubvalue, ProdID, KeyHash)

With Buffer
    .InsertDWORD ClientToken
    .InsertDWORD Version
    .InsertDWORD CheckSum
    If UseExpansion = True Then
        .InsertDWORD &H2
    Else
        .InsertDWORD &H1
    End If
    .InsertDWORD &H0
    
    'Key 1
    .InsertDWORD Len(CDKey)
    .InsertDWORD ProdID
    .InsertDWORD Pubvalue
    .InsertDWORD &H0
    .InsertNonNTString KeyHash
    
    'Key 2
    If UseExpansion = True Then
        dcResponse = decode_hash_cdkey(XPCDKey, ClientToken, ServerToken, XPPubValue, XPProdID, KeyHashXP)
        .InsertDWORD Len(XPCDKey)
        .InsertDWORD XPProdID
        .InsertDWORD XPPubValue
        .InsertDWORD &H0
        .InsertNonNTString KeyHashXP
    End If
    
    
    EXEInfo = Buffer.KillNull(EXEInfo)
    
    .InsertNTString EXEInfo
    .InsertNTString CDKeyOwner
    .SendPacket &H51, wsBNCS
End With
    
End Sub
Private Sub Parse0x51(data As String)
Dim Result As Long

With Debuffer
    .DebuffPacket data
    .Advance (4)
    Result = .DebuffDWORD
End With
    
Select Case Result
    Case &H0
        RaiseEvent CheckRevisionPassed
        Select Case Product
            Case "WAR3"
                Send0x53
            Case "W3XP"
                Send0x53
            Case Else
                Send0x3A
        End Select
    Case &H100
        RaiseEvent CheckRevisionFailed("Old game version.")
        wsBNCS.Close
    Case &H101
        RaiseEvent CheckRevisionFailed("Invalid version.")
        wsBNCS.Close
    Case &H102
        RaiseEvent CheckRevisionFailed("Game version must be downgraded.")
        wsBNCS.Close
    Case &H200
        RaiseEvent CheckRevisionFailed("Invalid CDKey.")
        wsBNCS.Close
    Case &H201
        RaiseEvent CheckRevisionFailed("CDKey in use.")
        wsBNCS.Close
    Case &H202
        RaiseEvent CheckRevisionFailed("Banned CDKey.")
        wsBNCS.Close
    Case &H203
        RaiseEvent CheckRevisionFailed("Wrong product information.")
        wsBNCS.Close
        End Select
End Sub
Private Sub Send0x3A()
Dim Hash As String * 20

double_hash_password LCase(Password), ClientToken, ServerToken, Hash

With Buffer
    .InsertDWORD ClientToken
    .InsertDWORD ServerToken
    .InsertNonNTString Hash
    .InsertNTString Username
    .SendPacket &H3A, wsBNCS
End With



End Sub
Private Sub Parse0x3A(data As String)
Dim Result As Long

With Debuffer
    .DebuffPacket data
    .Advance (4)
    Result = .DebuffDWORD
End With

Select Case Result
    Case &H0
        RaiseEvent LoggedIn(Username, Product)
        Send0x14
        Send0x0A
        JoinChannel (HomeChannel)
    Case &H1
        RaiseEvent LoginError("Account doesn't exist.")
        Send0x3D
    Case &H2
        RaiseEvent LoginError("Incorrect password.")
        wsBNCS.Close
    Case &H6
        RaiseEvent LoginError("Account is closed.")
        wsBNCS.Close
End Select

End Sub
Private Sub Parse0x25(data As String)
Dim PingValue As Long

With Debuffer
    .DebuffPacket data
    .Advance (4)
    PingValue = .DebuffDWORD
End With

'I decided to send the ping response in the Parse sub because its easier.
'This does not happen anywhere else.

'It'll probably save some memory since I don't make PingValue used anywhere else and its Dimmed.

With Buffer
    .InsertDWORD PingValue
    .SendPacket &H25, wsBNCS
End With

End Sub
Private Sub Send0x0A()
With Buffer
    .InsertNTString Username
    .InsertBYTE &H0
    .SendPacket &HA, wsBNCS
End With
End Sub
Public Sub JoinChannel(strChannel As String)

With Buffer
    .InsertDWORD &H2
    .InsertNTString strChannel
    .SendPacket &HC, wsBNCS
End With
    
End Sub
Private Sub Parse0x0A(data As String)
    With Debuffer
        .DebuffPacket data
        .Advance (4)
        UniqueUsername = .DebuffNTString
    End With
End Sub
Private Sub Parse0x59()
If Register = True Then
    With Buffer
        .InsertNTString Email
        .SendPacket &H59, wsBNCS
    End With
    RaiseEvent Registered(Email, Username)
End If
End Sub
Private Sub Send0x3D()
Dim Hash As String * 20
    
    hash_password LCase(Password), Hash
    
    With Buffer
        .InsertNonNTString Hash
        .InsertNTString Username
        .SendPacket &H3D, wsBNCS
    End With
        
End Sub
Private Sub Parse0x3D(data As String)
Dim Result As Long
    
    With Debuffer
        .DebuffPacket data
        .Advance (4)
        Result = .DebuffDWORD
    End With
    
    Select Case Result
        Case &H0
            RaiseEvent CreatedAccount(Username)
            Send0x3A
        Case &H2
            RaiseEvent CreateAccountFailed(Username, "Name contained invalid characters.")
            wsBNCS.Close
        Case &H3
            RaiseEvent CreateAccountFailed(Username, "Named contained a banned word.")
            wsBNCS.Close
        Case &H4
            RaiseEvent CreateAccountFailed(Username, "Name already exists.")
            wsBNCS.Close
        Case &H6
            RaiseEvent CreateAccountFailed(Username, "Name did not contain enough alphanumeric characters.")
            wsBNCS.Close
    End Select
    
End Sub
Public Sub SendChat(strText As String)
With Buffer
    .InsertNTString strText
    .SendPacket &HE, wsBNCS
End With

If Mid(strText, 1, 1) = "/" Then
    Exit Sub
End If

RaiseEvent SentChat(strText)
End Sub
Private Sub Parse0x0F(data As String)
Dim EventID As Long
Dim Ping As Long
Dim User As String
Dim Text As String
Dim Flags As Long

With Debuffer
    .DebuffPacket data
    .Advance (4)
    EventID = .DebuffDWORD
    Flags = .DebuffDWORD
    Ping = .DebuffDWORD
    .Advance (12)
    User = .DebuffNTString
    Text = .DebuffNTString
End With
    
    Select Case EventID
        Case &H1
            RaiseEvent UserShow(User, Mid(Text, 1, 4), Flags, Ping)
        Case &H2
            RaiseEvent UserJoined(User, Ping, Mid(Text, 1, 4), Flags)
        Case &H3
            RaiseEvent UserLeave(User)
        Case &H4
            RaiseEvent ReceivedWhisper(User, Text)
        Case &H5
            RaiseEvent ReceivedChat(User, Text, Flags, Ping)
        Case &H6
            RaiseEvent ServerBroadcast(Text)
        Case &H7
            RaiseEvent JoinedChannel(Text)
        Case &H9
            RaiseEvent UserFlagUpdate(User, Mid(Text, 1, 4), Ping, Flags)
        Case &HA
            RaiseEvent SentWhisper(Text)
        Case &HD
            RaiseEvent BnetError("Channel is full.")
        Case &HE
            RaiseEvent BnetError("Channel doesn't exist.")
        Case &HF
            RaiseEvent BnetError("Channel is restricted.")
        Case &H12
            RaiseEvent InfoMessage(Text)
        Case &H13
            RaiseEvent BnetError(Text)
        Case &H17
            RaiseEvent Emote(User, Text)
    End Select
        
End Sub

Private Sub wsBNCS_Close()
RaiseEvent Disconnected
End Sub

Private Sub wsBNCS_Connect()
RaiseEvent Connected(BNETServer)
wsBNCS.SendData Chr(1)
Send0x50
End Sub

Private Sub wsBNCS_DataArrival(ByVal bytesTotal As Long)

Static strBuffer As String
Dim strTemp As String, lngLen As Long
wsBNCS.GetData strTemp, vbString
strBuffer = strBuffer & strTemp
    While Len(strBuffer) > 4
        lngLen = Buffer.GetWORD(Mid(strBuffer, 3, 2))
        If Len(strBuffer) < lngLen Then: Exit Sub
            ParseBNCS (Left(strBuffer, lngLen))
            strBuffer = Mid(strBuffer, lngLen + 1)
    Wend
End Sub

Private Sub wsBNCS_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
RaiseEvent WinsockError(Description, Number)
wsBNCS.Close
End Sub
Public Sub Connect()

    RaiseEvent Connecting(BNETServer)
    wsBNCS.Close
    wsBNCS.Connect BNETServer, 6112
    
End Sub
Public Sub Disconnect()
    wsBNCS.Close
    RaiseEvent Disconnected
End Sub
Public Sub RequestFriends()
Buffer.SendPacket &H65, wsBNCS
End Sub
Private Sub Parse0x65(data As String)
Dim Account As String
Dim Total As Byte
Dim Status As Byte
Dim Location As Byte
Dim ProductID As Long
Dim LocationName As String

With Debuffer
    .DebuffPacket data
    .Advance (4)
    Total = .DebuffBYTE
    For i = 0 To Total
        Account = .DebuffNTString
        Status = .DebuffBYTE
        Location = .DebuffBYTE
        ProductID = .DebuffDWORD
        LocationName = .DebuffNTString
        RaiseEvent ReceivedFriends(Account, Status, LocationName, ProductID)
    Next i
End With
End Sub
Private Sub Send0x14()
If UsePlug = False Then
    Buffer.InsertNonNTString "tenb"
    Buffer.SendPacket &H14, wsBNCS
End If
End Sub
Private Sub Send0x53()
Dim BufferOut As String
BufferOut = Space(Len(Username) + 33)
hNLS = nls_init(Username, Password)

nls_account_logon hNLS, BufferOut

Buffer.InsertNonNTString BufferOut
Buffer.SendPacket &H53, wsBNCS

End Sub
Private Sub Parse0x53(data As String)
Dim Status As Long

With Debuffer
    .DebuffPacket data
    .Advance (4)
    Status = .DebuffDWORD
    Salt = .DebuffRaw(32)
    ServerKey = .DebuffRaw(32)
End With

Select Case Status
    Case &H0
        Send0x54
    Case &H1
        RaiseEvent LoginError("Account doesn't exist.")
        wsBNCS.Close
    Case &H5
        RaiseEvent LoginError("Account requires upgrade.")
End Select

End Sub
Private Sub Send0x54()
Dim BufferOut As String * 20

nls_account_logon_proof hNLS, BufferOut, ServerKey, Salt

Buffer.InsertNonNTString BufferOut
Buffer.SendPacket &H54, wsBNCS

nls_free (hNLS)

hNLS = 0


End Sub
Private Sub parse0x54(data As String)
Dim Status As Long

With Debuffer
    .DebuffPacket data
    .Advance (4)
    Status = .DebuffDWORD
End With

Select Case Status
    Case &H0
        RaiseEvent LoggedIn(Username, Product)
        Send0x0A
        JoinChannel (HomeChannel)
    Case &H2
        RaiseEvent LoginError("Incorrect password.")
    Case &HE
        Parse0x59
        RaiseEvent LoggedIn(Username, Product)
        Send0x0A
        JoinChannel (HomeChannel)
End Select
End Sub
Public Sub RequestProfile(strUsername As String)
With Buffer
    .InsertDWORD 1
    .InsertDWORD 4
    .InsertDWORD &H1
    .InsertNTString strUsername
    .InsertNTString "profile\sex"
    .InsertNTString "profile\age"
    .InsertNTString "profile\location"
    .InsertNTString "profile\Description"
    .SendPacket &H26, wsBNCS
End With
End Sub
Private Sub parse0x26(data As String)
'On Error GoTo Err

'I'm going to check for an error, which will happen.
'Every time that they call account info and receive 0x26
'So this error handler will exit the sub and continue
'With the RequestAccountInfo call

Dim AccountCount As Long
Dim KeyNumber As Long
Dim ReqID As Long
Dim Keys() As String
Dim i As Integer
Dim Location As String
Dim Sex As String
Dim Description As String
Dim ReqAccount As String

With Debuffer
    .DebuffPacket data
    .Advance (4)
    AccountCount = .DebuffDWORD
    KeyNumber = .DebuffDWORD
    ReqID = .DebuffDWORD
    
    If ReqID = &H2 Then
        'At the time I didn't realize the purpose of the request ID
        'This is sloppy but it works.
        ParseAccountInfo (data)
        Exit Sub
    End If
    
    Keys() = Split(Debuffer.Debuffer, Chr(0))
    Sex = Keys(0)
    Location = Keys(2)
    Description = Keys(3)
End With


RaiseEvent ReceivedProfile(Sex, Location, Description)

Exit Sub

Err:
Exit Sub

End Sub
Public Sub WriteProfile(strUsername As String, strSex As String, strLocation As String, strDescription As String)
    With Buffer
        .InsertDWORD 1
        .InsertDWORD 4
        .InsertNTString strUsername
        .InsertNTString "profile\sex"
        .InsertNTString "profile\age"
        .InsertNTString "profile\location"
        .InsertNTString "profile\description"
        .InsertNTString strSex
        .InsertNTString "20"
        .InsertNTString strLocation
        .InsertNTString strDescription
        .SendPacket &H27, wsBNCS
    End With
End Sub
Public Sub RequestAccountInfo(strUsername As String)

With Buffer
    .InsertDWORD 1
    .InsertDWORD 4
    .InsertDWORD &H2
    .InsertNTString strUsername
    .InsertNTString "System\Account Created"
    .InsertNTString "System\Last Logon"
    .InsertNTString "System\Last Logoff"
    .InsertNTString "System\Time Logged"
    .SendPacket &H26, wsBNCS
End With

End Sub
Private Sub ParseAccountInfo(data As String)

Dim RequestID As Long
Dim AccountNumber As Long
Dim KeyCount As Long
Dim SpltKeys() As String
Dim SpltFiletime() As String
Dim FTime As FILETIME
Dim STime As SYSTEMTIME
Dim i As Integer

Dim Created As String
Dim LastLogin As String
Dim LastLogOff As String
Dim TimeLogged As String
Dim TimeLoggedMin As Long
Dim TimeLoggedHour As Long
Dim TimeLoggedSecond As Long
Dim TimeLoggedDay As Long

With Debuffer
    .DebuffPacket data
    .Advance (4)
    AccountNumber = .DebuffDWORD
    KeyCount = .DebuffDWORD
    RequestID = .DebuffDWORD
    SpltKeys() = Split(.Debuffer, Chr(0), 4)
    For i = 0 To UBound(SpltKeys())
    Select Case i
        Case 0
            FileTimeToSystemTime MakeFT(SpltKeys(i)), STime
            Created = "Account Created: " & MonthName(STime.wMonth, False) & " " & STime.wDay & ", " & STime.wYear & " (" & STime.wHour & ":" & Format$(STime.wMinute, "00") & ":" & Format$(STime.wSecond, "00") & ")"
        Case 1
            FileTimeToSystemTime MakeFT(SpltKeys(i)), STime
            LastLogin = "Last Login: " & MonthName(STime.wMonth, False) & " " & STime.wDay & ", " & STime.wYear & " (" & STime.wHour & ":" & Format$(STime.wMinute, "00") & ":" & Format$(STime.wSecond, "00") & ")"
        Case 2
            FileTimeToSystemTime MakeFT(SpltKeys(i)), STime
            LastLogOff = "Last Logoff: " & MonthName(STime.wMonth, False) & " " & STime.wDay & ", " & STime.wYear & " (" & STime.wHour & ":" & Format$(STime.wMinute, "00") & ":" & Format$(STime.wSecond, "00") & ")"
        Case 3
            TimeLogged = ParseTime(SpltKeys(i))
    End Select
    Next i
End With

RaiseEvent AccountInformation(Created, LastLogin, LastLogOff, TimeLogged)

End Sub
Private Function MakeFT(ByVal FromStr As String) As FILETIME
'Function coded by RealityRipple


  MakeFT.dwHighDateTime = MakeLongSize(Split(FromStr, " ")(0))
  MakeFT.dwLowDateTime = MakeLongSize(Split(FromStr, " ")(1))



End Function

Private Function MakeLongSize(ByVal BigNumber As Double) As Long
'Function coded by RealityRipple

  Do While BigNumber > &H7FFFFFFF
    BigNumber = BigNumber - &H7FFFFFFF
  Loop
  MakeLongSize = BigNumber
  
End Function
Private Function ParseTime(ByVal GTC) As String
    'Coded by Victim
    'I'm bad at math and always have been so he gave me this code to help me out.
    
    Dim Count, Days As Integer, Hours As Integer, Minutes As Integer, Seconds As Integer
        Count = GTC
        Seconds = Count Mod 60
        Count = Count \ 60
        Days = Count \ (24& * 60&)
        If Days > 0 Then Count = Count - (24& * 60& * Days)
        Hours = Count \ 60&
        If Hours > 0 Then Count = Count - (60& * Hours)
        Minutes = Count Mod 60
        
        ParseTime = "Time Logged: " & Days & " days, " & Minutes & " minutes, " & Seconds & ", seconds"
        
End Function
