VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPacketBuffer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal numBytes As Long)
Private Buffer As String

Public Function InsertDWORD(data As Long)
Buffer = Buffer & MakeDWORD(data)
End Function
Public Function InsertWORD(data As Integer)
Buffer = Buffer & MakeWORD(data)
End Function
Public Function InsertBYTE(data As Integer)
Buffer = Buffer & Chr(data)
End Function
Public Function InsertNTString(data As String)
Buffer = Buffer & data & Chr(0)
End Function
Public Function InsertNonNTString(data As String)
Buffer = Buffer & data
End Function
Function MakeDWORD(Value As Long) As String
Dim Result As String * 4
CopyMemory ByVal Result, Value, 4
MakeDWORD = Result
End Function
Function MakeWORD(Value As Integer) As String
Dim Result As String * 2
CopyMemory ByVal Result, Value, 2
MakeWORD = Result
End Function
Public Function Clear()
Buffer = ""
End Function
Public Function SendPacket(packetID As Byte, Sock As Winsock)
Sock.SendData Chr(&HFF) & Chr(packetID) & MakeWORD(Len(Buffer) + 4) & Buffer
Clear
End Function
Public Function GetWORD(data As String) As Long

    Dim lReturn As Long
    Call CopyMemory(lReturn, ByVal data, 2)
    GetWORD = lReturn

End Function

Public Function KillNull(ByVal Text As String) As String


    Dim i As Integer
    i = InStr(1, Text, Chr(0))
    
    If i = 0 Then
        KillNull = Text
        Exit Function
    End If
    
    KillNull = Left(Text, i - 1)

End Function
Public Function GetBuffer() As String
GetBuffer = Buffer
End Function
Public Function SendBNLSPacket(packetID As Byte, Sock As Winsock)
    Sock.SendData MakeWORD(Len(Buffer) + 3) & Chr(packetID) & Buffer
    Clear
End Function
Public Function DebugOutput(ByVal sIn As String) As String

     Dim X1 As Long, Y1 As Long
     Dim iLen As Long, iPos As Long
     Dim sB As String, sT As String
     Dim sOut As String
     Dim Offset As Long, sOffset As String
      
     iLen = Len(sIn)
     
     If iLen = 0 Then Exit Function
     
     sOut = ""
     Offset = 0
     
     For X1 = 0 To ((iLen - 1) \ 16)
         
         sOffset = Right$("0000" & Hex(Offset), 4)
         sB = String(48, " ")
         sT = "................"
         
         For Y1 = 1 To 16
             iPos = 16 * X1 + Y1
             
             If iPos > iLen Then Exit For
             
             Mid(sB, 3 * (Y1 - 1) + 1, 2) = Right("00" & Hex(Asc(Mid(sIn, iPos, 1))), 2) & " "
             
             Select Case Asc(Mid(sIn, iPos, 1))
                Case 0, 9, 10, 13
                Case Else
                    Mid(sT, Y1, 1) = Mid(sIn, iPos, 1)
             End Select
         Next Y1
         
         If Len(sOut) > 0 Then sOut = sOut & vbCrLf
         
         sOut = sOut & sOffset & ":  "
         sOut = sOut & sB & "  " & sT
         Offset = Offset + 16
         
     Next X1
     
     DebugOutput = sOut

 End Function
