Attribute VB_Name = "modFunctions"
Option Explicit
Public Sub AddChat(Index As Integer, ParamArray saElements() As Variant)
    'Original written by Grok
    Dim TimeSetting As String
    
    If frmMenus.mnuLockWindow.Checked = True Then
        Exit Sub
    End If
    
    If frmMenus.mnuMilTime.Checked = True Then
        TimeSetting = Format(CDate(Time), "hh:nn:ss")
    Else
        TimeSetting = Time
    End If
    
    Dim i As Integer
        With frmMain.rtbChat(Index)
            .SelStart = Len(.Text)
            .SelLength = 0
            .SelColor = &H808080
            .SelFontSize = "8"
            .SelText = "[" & TimeSetting & "] "
            .SelStart = Len(.Text)
        End With
    For i = LBound(saElements) To UBound(saElements) Step 2
        With frmMain.rtbChat(Index)
            .SelHangingIndent = 1000
            .SelStart = Len(.Text)
            .SelLength = 0
            .SelColor = saElements(i)
            .SelFontSize = "8"
            .SelText = saElements(i + 1) & Left$(vbCrLf, -2 * CLng((i + 1) = UBound(saElements)))
            .SelStart = Len(.Text)
        End With
    Next i
End Sub
Public Function GetStuff(appname As String, Key As String, Optional strIni As String) As String
On Error GoTo Err

Dim sFile As String
Dim sDefault As String
Dim lSize As Integer
Dim l As Long
Dim sUser As String

sUser = Space$(128)
lSize = Len(sUser)

sFile = strIni

sDefault = ""
l = GetPrivateProfileString(appname, Key, sDefault, sUser, lSize, sFile)
sUser = Mid(sUser, 1, InStr(sUser, Chr(0)) - 1)
GetStuff = sUser

Exit Function
Err:
Exit Function

End Function
Public Function WriteSTuff(appname As String, Key As String, sString As String, Optional strIni As String) As Boolean
Dim sFile As String
Dim l As Long

WriteSTuff = False

On Error GoTo WriteStuff_Error
 sFile = strIni

l = WritePrivateProfileString(appname, Key, sString, sFile)
WriteSTuff = True


WriteStuff_Error:
If Err.Number <> 0 Then
MsgBox Err.Description
End If

End Function
Public Sub LoadAndSet(strPath As String, Index As Integer)
On Error Resume Next


frmMain.BNCS(Index).Username = GetStuff("Main", "Username", strPath)
frmMain.BNCS(Index).Password = GetStuff("Main", "Password", strPath)
frmMain.BNCS(Index).Product = GetStuff("Main", "Product", strPath)
frmMain.BNCS(Index).BNETServer = GetStuff("Main", "Server", strPath)
frmMain.BNCS(Index).Email = GetStuff("Main", "Email", strPath)

If frmMain.BNCS(Index).Email = "" Then
    frmMain.BNCS(Index).Register = False
Else
    frmMain.BNCS(Index).Register = True
End If

frmMain.BNCS(Index).CDKeyOwner = "Midnight Chat"
frmMain.BNCS(Index).HomeChannel = GetStuff("Main", "Home", strPath)
frmMain.BNCS(Index).Verbyte = GetStuff("Main", "Verbyte", strPath)

If frmMain.BNCS(Index).Verbyte = "" Then
    Select Case frmMain.BNCS(Index).Product
        Case "W2BN"
            frmMain.BNCS(Index).Verbyte = "4F"
        Case "D2DV"
            frmMain.BNCS(Index).Verbyte = "0C"
        Case "D2XP"
            frmMain.BNCS(Index).UseExpansion = True
            frmMain.BNCS(Index).Verbyte = "OC"
        Case "WAR3"
            frmMain.BNCS(Index).Verbyte = "17"
        Case "W3XP"
            frmMain.BNCS(Index).UseExpansion = True
            frmMain.BNCS(Index).Verbyte = "17"
    End Select
End If

frmMain.BNCS(Index).CDKey = GetStuff("Main", "CDKey", strPath)
frmMain.BNCS(Index).XPCDKey = GetStuff("Main", "XPKey", strPath)
frmMain.BNCS(Index).HashPath = App.Path & "\Hashes"

frmMain.BNCS(Index).SettingsPath = strPath

With frmSetup
    .txtUser.Text = frmMain.BNCS(Index).Username
    .txtPass.Text = frmMain.BNCS(Index).Password
    .txtKey.Text = frmMain.BNCS(Index).CDKey
    .txtXPKey.Text = frmMain.BNCS(Index).XPCDKey
    .txtHome.Text = frmMain.BNCS(Index).HomeChannel
    .txtVerbyte.Text = GetStuff("Main", "Verbyte", strPath)
    .txtEmail.Text = frmMain.BNCS(Index).Email
    .cmbServer.Text = frmMain.BNCS(Index).BNETServer
    .cmbGame.Text = frmMain.BNCS(Index).Product
    .txtIdle.Text = GetStuff("Main", "IdleMsg", strPath)
    .cmbStyle.Text = GetStuff("Main", "IdleType", strPath)
    .txtIdleWait.Text = GetStuff("Main", "IdleCount", strPath)
End With

End Sub
Public Sub WriteProfile(strPath As String)
On Error GoTo Err

With frmSetup
    WriteSTuff "Main", "Username", .txtUser.Text, strPath
    WriteSTuff "Main", "Password", .txtPass.Text, strPath
    WriteSTuff "Main", "Product", .cmbGame.Text, strPath
    WriteSTuff "Main", "Server", .cmbServer.Text, strPath
    WriteSTuff "Main", "Email", .txtEmail.Text, strPath
    WriteSTuff "Main", "Home", .txtHome.Text, strPath
    WriteSTuff "Main", "Verbyte", .txtVerbyte.Text, strPath
    WriteSTuff "Main", "CDKey", .txtKey.Text, strPath
    WriteSTuff "Main", "XPKey", .txtXPKey.Text, strPath
    WriteSTuff "Main", "IdleType", .cmbStyle.Text, strPath
    WriteSTuff "Main", "IdleMsg", .txtIdle.Text, strPath
    WriteSTuff "Main", "IdleCount", .txtIdleWait.Text, strPath
End With

Exit Sub
Err:
MsgBox "I received an error when saving your profile, perhaps you entered some data incorrectly.", vbInformation
End Sub
Public Sub Main()

frmSplash.Show

End Sub

